<?php
/*
version 0.1.2
*/
	class COD4ServerStatus{               /* Class taken from a file shared By Neho (from old cod4x forum) */
		var $server = '';
		var $port = '28960';
		var $protocol = 'udp';
		var $data = '';
		var $serverData = array();
		var $players = array();
		var $scores = array();
		var $pings = array();
		var $meta = array();
		var $timeout = 3;

	  function COD4ServerStatus($server, $port, $timeout = 1){
			$this->server = $server;
			$this->port = $port;
			$this->timeout = $timeout;
		}		
		

	function getServerStatus(){
			$error = false;
			
			if (!empty($this->server) && !empty($this->port)){					
				$handle = @fsockopen($this->protocol . '://' . $this->server, $this->port);
				
				if ($handle){				
					//socket_set_timeout($handle, $timeout);
					stream_set_blocking($handle, 1);
					stream_set_timeout($handle, 5);
							
					fputs($handle, "\xFF\xFF\xFF\xFFgetstatus\x00");
					fwrite($handle, "\xFF\xFF\xFF\xFFgetstatus\x00");					
					
					$this->data = fread($handle, 8192);
					$this->meta = stream_get_meta_data($handle);
					$counter = 8192;
					
					while (!feof($handle) && !$error && $counter < $this->meta['unread_bytes']){
						$this->data .= fread($handle, 8192);
						$this->meta = stream_get_meta_data($handle);
						
						if ($this->meta['timed_out']){
							$error = true;
						}
						
						$counter += 8192;
					}
					
					if ($error){
						echo 'Request timed out.';
						return false;							
					}else{
						if (strlen(trim($this->data)) == 0){							
							echo 'No data received from server.';
							return false;
						}else{
							return true;
						}
					}
				}else{
					echo 'Could not connect to server.';
					return false;
				}
				
				fclose($handle);
			}
		}
		
	
}	
	
	$server_port = 28960;
	if(isset($_GET['ip']) && $_GET['ip'] != '' ) $server_ip = $_GET['ip'];
    else {
		echo 'Invalid IP...Provide Valid IP';
		return;
		}

	if(isset($_GET['port']) && $_GET['port'] != '' ) $server_port = $_GET['port'];
	
	
	$status = new COD4ServerStatus(''.$server_ip.'', ''.$server_port.'');		
		
	if ($status->getServerStatus()){                  
		$data= $status->data;
                  echo $data;		
	}

      
	$capturelog=fopen("ServerInfo.log", "a");
	fwrite($capturelog,"\n IP: ".$_GET['ip']."   Port : ".$_GET['port']."\n".$data);
	fclose($capturelog);
	

?>
		